xref: /openbmc/linux/scripts/link-vmlinux.sh (revision 6e10e219)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41	printf "  %-7s %s\n" "${1}" "${2}"
42}
43
44# Generate a linker script to ensure correct ordering of initcalls.
45gen_initcalls()
46{
47	info GEN .tmp_initcalls.lds
48
49	${PYTHON} ${srctree}/scripts/jobserver-exec		\
50	${PERL} ${srctree}/scripts/generate_initcall_order.pl	\
51		${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}	\
52		> .tmp_initcalls.lds
53}
54
55# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
56# .tmp_symversions.lds
57gen_symversions()
58{
59	info GEN .tmp_symversions.lds
60	rm -f .tmp_symversions.lds
61
62	for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
63		if [ -f ${o}.symversions ]; then
64			cat ${o}.symversions >> .tmp_symversions.lds
65		fi
66	done
67}
68
69# Link of vmlinux.o used for section mismatch analysis
70# ${1} output file
71modpost_link()
72{
73	local objects
74	local lds=""
75
76	objects="--whole-archive				\
77		${KBUILD_VMLINUX_OBJS}				\
78		--no-whole-archive				\
79		--start-group					\
80		${KBUILD_VMLINUX_LIBS}				\
81		--end-group"
82
83	if [ -n "${CONFIG_LTO_CLANG}" ]; then
84		gen_initcalls
85		lds="-T .tmp_initcalls.lds"
86
87		if [ -n "${CONFIG_MODVERSIONS}" ]; then
88			gen_symversions
89			lds="${lds} -T .tmp_symversions.lds"
90		fi
91
92		# This might take a while, so indicate that we're doing
93		# an LTO link
94		info LTO ${1}
95	else
96		info LD ${1}
97	fi
98
99	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
100}
101
102objtool_link()
103{
104	local objtoolcmd;
105	local objtoolopt;
106
107	if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
108		# Don't perform vmlinux validation unless explicitly requested,
109		# but run objtool on vmlinux.o now that we have an object file.
110		if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
111			objtoolcmd="orc generate"
112		fi
113
114		objtoolopt="${objtoolopt} --duplicate"
115
116		if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
117			objtoolopt="${objtoolopt} --mcount"
118		fi
119	fi
120
121	if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
122		objtoolopt="${objtoolopt} --noinstr"
123	fi
124
125	if [ -n "${objtoolopt}" ]; then
126		if [ -z "${objtoolcmd}" ]; then
127			objtoolcmd="check"
128		fi
129		objtoolopt="${objtoolopt} --vmlinux"
130		if [ -z "${CONFIG_FRAME_POINTER}" ]; then
131			objtoolopt="${objtoolopt} --no-fp"
132		fi
133		if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
134			objtoolopt="${objtoolopt} --no-unreachable"
135		fi
136		if [ -n "${CONFIG_RETPOLINE}" ]; then
137			objtoolopt="${objtoolopt} --retpoline"
138		fi
139		if [ -n "${CONFIG_X86_SMAP}" ]; then
140			objtoolopt="${objtoolopt} --uaccess"
141		fi
142		if [ -n "${CONFIG_SLS}" ]; then
143			objtoolopt="${objtoolopt} --sls"
144		fi
145		info OBJTOOL ${1}
146		tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
147	fi
148}
149
150# Link of vmlinux
151# ${1} - output file
152# ${2}, ${3}, ... - optional extra .o files
153vmlinux_link()
154{
155	local output=${1}
156	local objs
157	local libs
158	local ld
159	local ldflags
160	local ldlibs
161
162	info LD ${output}
163
164	# skip output file argument
165	shift
166
167	if [ -n "${CONFIG_LTO_CLANG}" ]; then
168		# Use vmlinux.o instead of performing the slow LTO link again.
169		objs=vmlinux.o
170		libs=
171	else
172		objs="${KBUILD_VMLINUX_OBJS}"
173		libs="${KBUILD_VMLINUX_LIBS}"
174	fi
175
176	if [ "${SRCARCH}" = "um" ]; then
177		wl=-Wl,
178		ld="${CC}"
179		ldflags="${CFLAGS_vmlinux}"
180		ldlibs="-lutil -lrt -lpthread"
181	else
182		wl=
183		ld="${LD}"
184		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
185		ldlibs=
186	fi
187
188	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
189
190	# The kallsyms linking does not need debug symbols included.
191	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
192		ldflags="${ldflags} ${wl}--strip-debug"
193	fi
194
195	if [ -n "${CONFIG_VMLINUX_MAP}" ]; then
196		ldflags="${ldflags} ${wl}-Map=${output}.map"
197	fi
198
199	${ld} ${ldflags} -o ${output}					\
200		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
201		${wl}--start-group ${libs} ${wl}--end-group		\
202		$@ ${ldlibs}
203}
204
205# generate .BTF typeinfo from DWARF debuginfo
206# ${1} - vmlinux image
207# ${2} - file to dump raw BTF data into
208gen_btf()
209{
210	local pahole_ver
211
212	if ! [ -x "$(command -v ${PAHOLE})" ]; then
213		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
214		return 1
215	fi
216
217	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
218	if [ "${pahole_ver}" -lt "116" ]; then
219		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
220		return 1
221	fi
222
223	vmlinux_link ${1}
224
225	info "BTF" ${2}
226	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
227
228	# Create ${2} which contains just .BTF section but no symbols. Add
229	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
230	# deletes all symbols including __start_BTF and __stop_BTF, which will
231	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
232	# objcopy warnings: "empty loadable segment detected at ..."
233	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
234		--strip-all ${1} ${2} 2>/dev/null
235	# Change e_type to ET_REL so that it can be used to link final vmlinux.
236	# Unlike GNU ld, lld does not allow an ET_EXEC input.
237	printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
238}
239
240# Create ${2} .S file with all symbols from the ${1} object file
241kallsyms()
242{
243	local kallsymopt;
244
245	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
246		kallsymopt="${kallsymopt} --all-symbols"
247	fi
248
249	if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
250		kallsymopt="${kallsymopt} --absolute-percpu"
251	fi
252
253	if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
254		kallsymopt="${kallsymopt} --base-relative"
255	fi
256
257	info KSYMS ${2}
258	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
259}
260
261# Perform one step in kallsyms generation, including temporary linking of
262# vmlinux.
263kallsyms_step()
264{
265	kallsymso_prev=${kallsymso}
266	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
267	kallsymso=${kallsyms_vmlinux}.o
268	kallsyms_S=${kallsyms_vmlinux}.S
269
270	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
271	kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
272
273	info AS ${kallsyms_S}
274	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
275	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
276	      -c -o ${kallsymso} ${kallsyms_S}
277}
278
279# Create map file with all symbols from ${1}
280# See mksymap for additional details
281mksysmap()
282{
283	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
284}
285
286sorttable()
287{
288	${objtree}/scripts/sorttable ${1}
289}
290
291# Delete output files in case of error
292cleanup()
293{
294	rm -f .btf.*
295	rm -f .tmp_System.map
296	rm -f .tmp_initcalls.lds
297	rm -f .tmp_symversions.lds
298	rm -f .tmp_vmlinux*
299	rm -f System.map
300	rm -f vmlinux
301	rm -f vmlinux.map
302	rm -f vmlinux.o
303	rm -f .vmlinux.d
304}
305
306# Use "make V=1" to debug this script
307case "${KBUILD_VERBOSE}" in
308*1*)
309	set -x
310	;;
311esac
312
313if [ "$1" = "clean" ]; then
314	cleanup
315	exit 0
316fi
317
318# We need access to CONFIG_ symbols
319. include/config/auto.conf
320
321# Update version
322info GEN .version
323if [ -r .version ]; then
324	VERSION=$(expr 0$(cat .version) + 1)
325	echo $VERSION > .version
326else
327	rm -f .version
328	echo 1 > .version
329fi;
330
331# final build of init/
332${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
333
334#link vmlinux.o
335modpost_link vmlinux.o
336objtool_link vmlinux.o
337
338# modpost vmlinux.o to check for section mismatches
339${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
340
341info MODINFO modules.builtin.modinfo
342${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
343info GEN modules.builtin
344# The second line aids cases where multiple modules share the same object.
345tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
346	tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
347
348btf_vmlinux_bin_o=""
349if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
350	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
351	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
352		echo >&2 "Failed to generate BTF for vmlinux"
353		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
354		exit 1
355	fi
356fi
357
358kallsymso=""
359kallsymso_prev=""
360kallsyms_vmlinux=""
361if [ -n "${CONFIG_KALLSYMS}" ]; then
362
363	# kallsyms support
364	# Generate section listing all symbols and add it into vmlinux
365	# It's a three step process:
366	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
367	#     but __kallsyms is empty.
368	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
369	#     the right size
370	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
371	#     the right size, but due to the added section, some
372	#     addresses have shifted.
373	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
374	# 3)  That link may have expanded the kernel image enough that
375	#     more linker branch stubs / trampolines had to be added, which
376	#     introduces new names, which further expands kallsyms. Do another
377	#     pass if that is the case. In theory it's possible this results
378	#     in even more stubs, but unlikely.
379	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
380	#     other bugs.
381	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
382	#
383	# a)  Verify that the System.map from vmlinux matches the map from
384	#     ${kallsymso}.
385
386	kallsyms_step 1
387	kallsyms_step 2
388
389	# step 3
390	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
391	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
392
393	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
394		kallsyms_step 3
395	fi
396fi
397
398vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
399
400# fill in BTF IDs
401if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
402	info BTFIDS vmlinux
403	${RESOLVE_BTFIDS} vmlinux
404fi
405
406info SYSMAP System.map
407mksysmap vmlinux System.map
408
409if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
410	info SORTTAB vmlinux
411	if ! sorttable vmlinux; then
412		echo >&2 Failed to sort kernel tables
413		exit 1
414	fi
415fi
416
417# step a (see comment above)
418if [ -n "${CONFIG_KALLSYMS}" ]; then
419	mksysmap ${kallsyms_vmlinux} .tmp_System.map
420
421	if ! cmp -s System.map .tmp_System.map; then
422		echo >&2 Inconsistent kallsyms data
423		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
424		exit 1
425	fi
426fi
427
428# For fixdep
429echo "vmlinux: $0" > .vmlinux.d
430